/*
 * main.c
 *
 *  Created on: 15 jan 2012
 *      Author: benjamin
 */
#include "LPC17xx.h"

/*
 * Macros
 */
#define	_BV(bit) 						(1<<(bit))

#define LED1_ON()						(LPC_GPIO2->FIOSET = _BV(8))
#define LED1_OFF()						(LPC_GPIO2->FIOCLR = _BV(8))
#define LED1_IS_ON						(LPC_GPIO2->FIOPIN & _BV(8))

/*
 * Variables
 */
volatile uint32_t ms_ticks;

void SysTick_Handler(void) {
	ms_ticks++;
}

void delay_ms (uint32_t dly_ticks) {
	uint32_t cur_ticks;

	cur_ticks = ms_ticks;
	while ((ms_ticks - cur_ticks) < dly_ticks);
}

void init() {
	SystemCoreClockUpdate();

	if (SysTick_Config(SystemCoreClock / 1000)) {
		while (1);
	}

	NVIC_SetPriority (SysTick_IRQn, 2);

	// LED Pin as output
	LPC_GPIO2->FIODIR |= _BV(8) | _BV(9);
}

int main (void) {
	init();

	for(;;) {
		LED1_ON();
		delay_ms(500);
		LED1_OFF();
		delay_ms(500);
	}
}
